"
 COPYRIGHT (c) 1994 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

PrimaryNode subclass:#SelfNode
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'System-Compiler-Support'
!

SelfNode comment:'
COPYRIGHT (c) 1994 by Claus Gittinger
             All Rights Reserved
'!

!SelfNode class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libcomp/SelfNode.st,v 1.2 1994-06-02 20:26:18 claus Exp $
"
!

documentation
"
    node for parse-trees, representing self
"
! !

!SelfNode class methodsFor:'instance creation'!

value:val
    ^ (self basicNew) value:val
! !

!SelfNode methodsFor:'accessing'!

value:val
    type := #Self.
    value := val.
! !

!SelfNode methodsFor:'evaluating'!

evaluate
    ^ value
!

store:aValue
    "not reached - parser has already checked this"

    self error:'store into self - cannot happen'
! !

!SelfNode methodsFor:'code generation'!

codeOn:aStream inBlock:codeBlock
    aStream nextPut:#pushSelf
!

codeStoreOn:aStream inBlock:codeBlock valueNeeded:valueNeeded
    "not reached - parser has already checked this"

    ^ self error:'store into self - cannot happen'
! !

!SelfNode methodsFor:'printing'!

displayString
    ^ 'InterpreterVariable(self)'
!

printOn:aStream indent:i
    aStream nextPutAll:'self'
! !
